Attribute VB_Name = "MCommonDialog"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses BYTES.BAS UTILITY.BAS
'
' commdlg.bas - Common dialog functions, types, and definitions
'

#If Win32 Then
''@B TOpenFileName32
Private Type TOpenFileName
    lStructSize As Long          ' Filled with UDT size
    hwndOwner As Long            ' Tied to vOwner
    hInstance As Long            ' Ignored (used only by templates)
    lpstrFilter As String        ' Tied to vFilter
    lpstrCustomFilter As String  ' Ignored (exercise for reader)
    nMaxCustFilter As Long       ' Ignored (exercise for reader)
    nFilterIndex As Long         ' Tied to vFilterIndex
    lpstrFile As String          ' Tied to vFileName
    nMaxFile As Long             ' Handled internally
    lpstrFileTitle As String     ' Tied to vFileTitle
    nMaxFileTitle As Long        ' Handle internally
    lpstrInitialDir As String    ' Tied to vInitDir
    lpstrTitle As String         ' Tied to vTitle
    Flags As Long                ' Tied to vFlags
    nFileOffset As Integer       ' Ignored (exercise for reader)
    nFileExtension As Integer    ' Ignored (exercise for reader)
    lpstrDefExt As String        ' Tied to vDefExt
    lCustData As Long            ' Ignored (needed for hooks)
    lpfnHook As Long             ' Ignored (no hooks in Basic)
    lpTemplateName As Long       ' Ignored (no templates in Basic)
End Type
''@E TOpenFileName32
#Else
''@B TOpenFileName1
Private Type TOpenFileName
    lStructSize As Long
    hwndOwner As Integer
    hInstance As Integer
    lpstrFilter As String
    ''@E TOpenFileName1...
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
''@B TOpenFileName2
End Type
''@E TOpenFileName2
#End If

#If Win32 Then
Private Declare Function GetOpenFileName Lib "COMDLG32" _
    Alias "GetOpenFileNameA" (file As TOpenFileName) As Long
Private Declare Function GetSaveFileName Lib "COMDLG32" _
    Alias "GetSaveFileNameA" (file As TOpenFileName) As Long
Private Declare Function GetFileTitle Lib "COMDLG32" _
    Alias "GetFileTitleA" (ByVal szFile As String, _
    ByVal szTitle As String, ByVal cbBuf As Long) As Long
#Else
Private Declare Function GetOpenFileName Lib "COMMDLG.DLL " ( _
    file As TOpenFileName) As Integer
Private Declare Function GetSaveFileName Lib "COMMDLG.DLL" ( _
    file As TOpenFileName) As Integer
Private Declare Function GetFileTitle Lib "COMMDLG.DLL" ( _
    ByVal szFile As String, ByVal szTitle As String, _
    ByVal cbBuf As Integer) As Integer
#End If


Public Const cdlOFNReadOnly = &H1
Public Const cdlOFNOverwritePrompt = &H2
Public Const cdlOFNHideReadOnly = &H4
Public Const cdlOFNNoChangeDir = &H8
Public Const cdlOFNFileShowHelp = &H10
Public Const cdlOFNNoValidate = &H100
Public Const cdlOFNAllowMultiselect = &H200
Public Const cdlOFNExtensionDifferent = &H400
Public Const cdlOFNPathMustExist = &H800
Public Const cdlOFNFileMustExist = &H1000
Public Const cdlOFNCreatePrompt = &H2000
Public Const cdlOFNShareAware = &H4000
Public Const cdlOFNNoReadOnlyReturn = &H8000
Public Const cdlOFNNoTestFileCreate = &H10000
' Win95 only
#If Win32 Then
Public Const cdlOFNExplorer = &H80000
Public Const cdlOFNNoDerefenceLinks = &H100000
Public Const cdlOFNLongnames = &H200000
#End If

#If Win32 Then
Private Type TChooseColor
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type
#Else
Private Type TChooseColor
    lStructSize As Long
    hwndOwner As Integer
    hInstance As Integer
    rgbResult As Long
    lpCustColors As Long
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type
#End If

#If Win32 Then
Private Declare Function ChooseColor Lib "COMDLG32.DLL" _
    Alias "ChooseColorA" (Color As TChooseColor) As Long
#Else
Private Declare Function ChooseColor Lib "COMMDLG.DLL" ( _
    Color As TChooseColor) As Integer
#End If

' Array of custom colors lasts for life of app
Private alCustom(0 To 15) As Long, fNotFirst As Boolean

Public Const cdlCCRGBInit = &H1
Public Const cdlCCFullOpen = &H2
Public Const cdlCCPreventFullOpen = &H4
Public Const cdlCCColorShowHelp = &H8
' Win95 only
#If Win32 Then
Public Const cdlCCSolidColor = &H80
Public Const cdlCCAnyColor = &H100
#End If
Private Const cdlCCEnableHook = &H10
Private Const cdlCCEnableTemplate = &H20
Private Const cdlCCEnableTemplateHandle = &H40

#If Win32 Then
    ''@B TChooseFont
Private Type TChooseFont
    lStructSize As Long         ' Structure size
    hwndOwner As Long           ' Caller's window handle
    hDC As Long                 ' Printer DC/IC or NULL
    lpLogFont As Long           ' Pointer to TLogFont
    ''@E TChooseFont...
    iPointSize As Long          ' 10 * size in points of font
    Flags As Long               ' Type flags
    rgbColors As Long           ' Returned text color
    lCustData As Long           ' Data passed to hook function
    lpfnHook As Long            ' Pointer to hook function
    lpTemplateName As Long      ' Custom template name
    hInstance As Long           ' Instance handle for template
    lpszStyle As String         ' Return style field
    nFontType As Integer        ' Font type bits
    iAlign As Integer           ' Filler
    nSizeMin As Long            ' Minimum point size allowed
    nSizeMax As Long            ' Maximum point size allowed
End Type
#Else
Private Type TChooseFont
    lStructSize As Long
    hwndOwner As Integer
    hDC As Integer
    lpLogFont As Long
    iPointSize As Integer
    Flags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
    hInstance As Integer
    lpszStyle As String
    nFontType As Integer
    nSizeMin As Integer
    nSizeMax As Integer
End Type
#End If

Private Const LF_FACESIZE = 32

''@B TLogFontB
Type TLogFontB
#If Win32 Then
   Height As Long
   Width As Long
   Escapement As Long
   Orientation As Long
   Weight As Long
#Else
   Height As Integer
   Width As Integer
   Escapement As Integer
   Orientation As Integer
   Weight As Integer
#End If
   Italic As Byte
   Underline As Byte
   StrikeOut As Byte
   CharSet As Byte
   OutPrecision As Byte
   ClipPrecision As Byte
   Quality As Byte
   PitchAndFamily As Byte
   FaceName(0 To 31) As Byte
End Type
''@E TLogFontB

#If Win32 Then
Private Declare Function ChooseFont Lib "COMDLG32" _
    Alias "ChooseFontA" (chfont As TChooseFont) As Long
#Else
Private Declare Function ChooseFont Lib "COMMDLG.DLL" ( _
    chfont As TChooseFont) As Integer
#End If

Public Const cdlCFScreenFonts = &H1
Public Const cdlCFPrinterFonts = &H2
Public Const cdlCFBoth = &H3
Public Const cdlCFFontShowHelp = &H4
Public Const cdlCFUseStyle = &H80
Public Const cdlCFEffects = &H100
Public Const cdlCFAnsiOnly = &H400
Public Const cdlCFNoVectorFonts = &H800
Public Const cdlCFNoOemFonts = cdlCFNoVectorFonts
Public Const cdlCFNoSimulations = &H1000
Public Const cdlCFLimitSize = &H2000
Public Const cdlCFFixedPitchOnly = &H4000
Public Const cdlCFWYSIWYG = &H8000  ' Must also have ScreenFonts And PrinterFonts
Public Const cdlCFForceFontExist = &H10000
Public Const cdlCFScalableOnly = &H20000
Public Const cdlCFTTOnly = &H40000
Public Const cdlCFNoFaceSel = &H80000
Public Const cdlCFNoStyleSel = &H100000
Public Const cdlCFNoSizeSel = &H200000
' Win95 only
#If Win32 Then
Public Const cdlCFSelectScript = &H400000
Public Const cdlCFNoScriptSel = &H800000
Public Const cdlCFNoVertFonts = &H1000000
#End If

Private Const cdlCFInitToLogFontStruct = &H40
'Private Const cdlCFApply = &H200
'Private Const cdlCFEnableHook = &H8
'Private Const cdlCFEnableTemplate = &H10
'Private Const cdlCFEnableTemplateHandle = &H20
Private Const cdlCFFontNotSupported = &H238

' these are extra nFontType bits that are added to what is returned to the
' EnumFonts callback routine

Public Const Simulated_FontType = &H8000
Public Const Printer_FontType = &H4000
Public Const Screen_FontType = &H2000
Public Const Bold_FontType = &H100
Public Const Italic_FontType = &H200
Public Const Regular_FontType = &H400

' Printer dialog implementation left as exercise for reader
#If Win32 Then
Private Type TPrintDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    Flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As Long
    lpSetupTemplateName As Long
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type
#Else
Private Type TPrintDlg
    lStructSize As Long
    hwndOwner As Integer
    hDevMode As Integer
    hDevNames As Integer
    hDC As Integer
    Flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Integer
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As Long
    lpSetupTemplateName As Long
    hPrintTemplate As Integer
    hSetupTemplate As Integer
End Type
#End If

' Exercise for reader
#If YouDoIt Then
#If Win32 Then
Private Declare Function PrintDlg Lib "COMDLG32.DLL" _
    Alias "PrintDlgA" (prtdlg As TPrintDlg) As Integer
#Else
Private Declare Function PrintDlg Lib "COMMDLG.DLL" ( _
    prtdlg As TPrintDlg) As Integer
#End If

Public Const cdlPDAllPages = &H0
Public Const cdlPDSelection = &H1
Public Const cdlPDPageNums = &H2
Public Const cdlPDNoSelection = &H4
Public Const cdlPDNoPageNums = &H8
Public Const cdlPDCollate = &H10
Public Const cdlPDPrintToFile = &H20
Public Const cdlPDPrintSetup = &H40
Public Const cdlPDNoWarning = &H80
Public Const cdlPDReturnDC = &H100
Public Const cdlPDReturnIC = &H200
Public Const cdlPDReturnDefault = &H400
Public Const cdlPDShowHelp = &H800
'Public Const cdlPDEnablePrintHook = &H1000
'Public Const cdlPDEnableSetupHook = &H2000
'Public Const cdlPDEnablePrintTemplate = &H4000
'Public Const cdlPDEnableSetupTemplate = &H8000
'Public Const cdlPDEnablePrintTemplateHandle = &H10000
'Public Const cdlPDEnableSetupTemplateHandle = &H20000
Public Const cdlPDUseDevModeCopies = &H40000
Public Const cdlPDDisablePrintToFile = &H80000
Public Const cdlPDHidePrintToFile = &H100000
Public Const cdlPDAall = &H1C0FFF

Private Type TDevNames
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
End Type

' New Win95 Page Setup dialogs are up to you

#If Win32 Then
Type TPageSetupDlg
    lStructSize                 As Long
    hwndOwner                   As Long
    hDevMode                    As Long
    hDevNames                   As Long
    Flags                       As Long
    ptPaperSize                 As TPoint
    rtMinMargin                 As TRect
    rtMargin                    As TRect
    hInstance                   As Long
    lCustData                   As Long
    lpfnPageSetupHook           As Long
    lpfnPagePaintHook           As Long
    lpPageSetupTemplateName     As Long
    hPageSetupTemplate          As Long
End Type

Private Declare Function PageSetupDlg Lib "COMDLG32" _
    Alias "PageSetupDlgA" (lppage As TPageSetupDlg) As Boolean

Public Const cdlPDDefaultminmargins = &H0 ' Default (printer's)
Public Const cdlPDInWinIniIntlMeasure = &H0
Public Const cdlPDMinMargins = &H1
Public Const cdlPDMargins = &H2
Public Const cdlPDInThousandthsOfInches = &H4
Public Const cdlPDInHundredthsOfMillimeters = &H8
Public Const cdlPDDisableMargins = &H10
Public Const cdlPDDisablePrinter = &H20
Public Const cdlPDNoWarning = &H80
Public Const cdlPDDisableOrientation = &H100
Public Const cdlPDReturnDefault = &H400
Public Const cdlPDDisablePaper = &H200
Public Const cdlPDShowHelp = &H800
'Public Const cdlPDEnablePageSetupHook = &H2000
'Public Const cdlPDEnablePageSetupTemplate = &H8000
'Public Const cdlPDEnablePageSetupTemplateHandle = &H20000
'Public Const cdlPDEnablePagePaintHook = &H40000
'Public Const cdlPDDisablePagePainting = &H80000
#End If ' Win32
#End If ' YouDoIt

' Common dialog errors

#If Win32 Then
Private Declare Function CommDlgExtendedError Lib "COMDLG32" () As Long
#Else
Private Declare Function CommDlgExtendedError Lib "COMMDLG.DLL" () As Long
#End If

Public Const CDERR_DIALOGFAILURE = &HFFFF

Public Const CDERR_GENERALCODES = &H0
Public Const CDERR_STRUCTSIZE = &H1
Public Const CDERR_INITIALIZATION = &H2
Public Const CDERR_NOTEMPLATE = &H3
Public Const CDERR_NOHINSTANCE = &H4
Public Const CDERR_LOADSTRFAILURE = &H5
Public Const CDERR_FINDRESFAILURE = &H6
Public Const CDERR_LOADRESFAILURE = &H7
Public Const CDERR_LOCKRESFAILURE = &H8
Public Const CDERR_MEMALLOCFAILURE = &H9
Public Const CDERR_MEMLOCKFAILURE = &HA
Public Const CDERR_NOHOOK = &HB
Public Const CDERR_REGISTERMSGFAIL = &HC

Public Const PDERR_PRINTERCODES = &H1000
Public Const PDERR_SETUPFAILURE = &H1001
Public Const PDERR_PARSEFAILURE = &H1002
Public Const PDERR_RETDEFFAILURE = &H1003
Public Const PDERR_LOADDRVFAILURE = &H1004
Public Const PDERR_GETDEVMODEFAIL = &H1005
Public Const PDERR_INITFAILURE = &H1006
Public Const PDERR_NODEVICES = &H1007
Public Const PDERR_NODEFAULTPRN = &H1008
Public Const PDERR_DNDMMISMATCH = &H1009
Public Const PDERR_CREATEICFAILURE = &H100A
Public Const PDERR_PRINTERNOTFOUND = &H100B
Public Const PDERR_DEFAULTDIFFERENT = &H100C

Public Const CFERR_CHOOSEFONTCODES = &H2000
Public Const CFERR_NOFONTS = &H2001
Public Const CFERR_MAXLESSTHANMIN = &H2002

Public Const FNERR_FILENAMECODES = &H3000
Public Const FNERR_SUBCLASSFAILURE = &H3001
Public Const FNERR_INVALIDFILENAME = &H3002
Public Const FNERR_BUFFERTOOSMALL = &H3003

Public Const CCERR_CHOOSECOLORCODES = &H5000

''@B VBGetOpenFileName1
Function VBGetOpenFileName(vFileName As Variant, _
                           Optional vFileTitle As Variant, _
                           Optional vFlags As Variant, _
                           Optional vOwner As Variant, _
                           Optional vFilter As Variant, _
                           Optional vFilterIndex As Variant, _
                           Optional vInitDir As Variant, _
                           Optional vTitle As Variant, _
                           Optional vDefExt As Variant) As Boolean
            
    Dim opfile As TOpenFileName, s As String
With opfile
    .lStructSize = Len(opfile)
    
    ' vFileName must get reference variable to receive result
    ' vFileTitle can get reference variable to receive title
    If IsMissing(vFileTitle) Then vFileTitle = sEmpty
    ' vFlags can get reference variable or constant with bit flags
    If IsMissing(vFlags) Then vFlags = 0
    ' vFilter can take list of filter strings separated by |
    If IsMissing(vFilter) Then vFilter = "All (*.*)| *.*"
    ' vFilterIndex can take initial filter index (one-based)
    If IsMissing(vFilterIndex) Then vFilterIndex = 1
    ' vOwner can take handle of owning window
    If Not IsMissing(vOwner) Then .hwndOwner = vOwner
    ' vInitDir can take initial directory string
    If Not IsMissing(vInitDir) Then .lpstrInitialDir = vInitDir
    ' vDefExt can take default extension
    If Not IsMissing(vDefExt) Then .lpstrDefExt = vDefExt
    ' vTitle can take dialog box title
    If Not IsMissing(vTitle) Then .lpstrTitle = vTitle
''@E VBGetOpenFileName1
    
''@B VBGetOpenFileName2
    ' To make Windows-style filter, replace pipes with nulls
    Dim ch As String, i As Integer
    For i = 1 To Len(vFilter)
        ch = Mid$(vFilter, i, 1)
        If ch = "|" Then
            s = s & sNullChr
        Else
            s = s & ch
        End If
    Next
    ' Put double null at end
    s = s & sNullChr & sNullChr
    .lpstrFilter = s
    .nFilterIndex = vFilterIndex
''@E VBGetOpenFileName2

''@B VBGetOpenFileName3
    ' Pad file and file title buffers to maximum path
    s = vFileName & String$(cMaxPath - Len(vFileName), 0)
    .lpstrFile = s
    .nMaxFile = cMaxPath
    s = vFileTitle & String$(cMaxFile - Len(vFileTitle), 0)
    .lpstrFileTitle = s
    .nMaxFileTitle = cMaxFile
''@E VBGetOpenFileName3
    
''@B VBGetOpenFileName4
    ' Pass in flags, stripping out non-VB flags
    .Flags = vFlags And &H1FF1F
''@E VBGetOpenFileName4

    ' All other fields zero
    '.lpstrCustomFilter = sNullStr ' Exercise for reader
    '.nMaxCustFilter = 0
    '.nFileOffset = 0              ' Exercise for reader
    '.nFileExtension = 0           ' Exercise for reader
    '.hInstance = hNull            ' No templates
    '.lpTemplateName = pNull
    '.lCustData = pNull            ' No hooks
    '.lpfnHook = pNull
    
''@B VBGetOpenFileName5
    If GetOpenFileName(opfile) Then
        VBGetOpenFileName = True
        vFileName = StrZToStr(.lpstrFile)
        vFileTitle = StrZToStr(.lpstrFileTitle)
        vFlags = .Flags
        vFilterIndex = .nFilterIndex
        vFilter = FilterLookup(vFilter, vFilterIndex)
    Else
        VBGetOpenFileName = False
        vFileName = sEmpty
        vFileTitle = sEmpty
        vFlags = 0
        vFilterIndex = 0
        vFilter = sEmpty
    End If
''@E VBGetOpenFileName5
End With
End Function

Private Function FilterLookup(ByVal sFilters As String, ByVal iCur As Integer) As String
    Dim i As Integer, iStart As Integer, iEnd As Integer
    Dim s As String
    iStart = 1
    If sFilters = sEmpty Then Exit Function
    Do
        iEnd = InStr(iStart, sFilters, "|")
        If iEnd = 0 Then Exit Function
        iEnd = InStr(iEnd + 1, sFilters, "|")
        If iEnd Then
            s = Mid$(sFilters, iStart, iEnd - iStart)
        Else
            s = Mid$(sFilters, iStart)
        End If
        iStart = iEnd + 1
        If iCur = 1 Then
            FilterLookup = s
            Exit Function
        End If
        iCur = iCur - 1
    Loop While iCur
    ' FilterLookup = sEmpty
End Function

Function VBGetSaveFileName(vFileName As String, _
                           Optional vFileTitle As Variant, _
                           Optional vFlags As Variant, _
                           Optional vOwner As Variant, _
                           Optional vFilter As Variant, _
                           Optional vFilterIndex As Variant, _
                           Optional vInitDir As Variant, _
                           Optional vTitle As Variant, _
                           Optional vDefExt As Variant) As Boolean
            
    Dim opfile As TOpenFileName, s As String
With opfile
    .lStructSize = Len(opfile)
    
    ' vFileName must get reference variable to receive result
    ' vFileTitle can get reference variable to receive title in BASE.EXT form
    If IsMissing(vFileTitle) Then vFileTitle = sEmpty
    ' vFlags can get reference variable or constant with bit flags
    If IsMissing(vFlags) Then vFlags = 0
    ' vFilter can take list of filter strings separated by | character
    If IsMissing(vFilter) Then vFilter = "All (*.*)| *.*"
    ' vFilterIndex can take initial filter index (one-based)
    If IsMissing(vFilterIndex) Then vFilterIndex = 1
    ' vOwner can take handle of owning window
    If Not IsMissing(vOwner) Then .hwndOwner = vOwner
    ' vInitDir can take initial directory string
    If Not IsMissing(vInitDir) Then .lpstrInitialDir = vInitDir
    ' vDefExt can take default extension
    If Not IsMissing(vDefExt) Then .lpstrDefExt = vDefExt
    ' vTitle can take dialog box title
    If Not IsMissing(vTitle) Then .lpstrTitle = vTitle
    
    ' Make new filter with bars (|) replacing nulls and double null at end
    Dim ch As String, i As Integer
    For i = 1 To Len(vFilter)
        ch = Mid$(vFilter, i, 1)
        If ch = "|" Then
            s = s & sNullChr
        Else
            s = s & ch
        End If
    Next
    s = s & sNullChr & sNullChr
    .lpstrFilter = s
    .nFilterIndex = vFilterIndex

    ' Pad file and file title buffers to maximum path
    s = vFileName & String$(cMaxPath - Len(vFileName), 0)
    .lpstrFile = s
    .nMaxFile = cMaxPath
    s = vFileTitle & String$(cMaxFile - Len(vFileTitle), 0)
    .lpstrFileTitle = s
    .nMaxFileTitle = cMaxFile
    
    ' Pass in flags, stripping out non-VB flags
    .Flags = vFlags And &H1FF1F

    ' All other fields zero
    '.lpstrCustomFilter = sNull    ' Exercise for reader
    '.nMaxCustFilter = 0
    '.nFileOffset = 0              ' Exercise for reader
    '.nFileExtension = 0           ' Exercise for reader
    '.hInstance = hNull            ' No templates
    '.lpTemplateName = pNull
    '.lCustData = pNull            ' No hooks
    '.lpfnHook = pNull
    
    If GetSaveFileName(opfile) Then
        VBGetSaveFileName = True
        vFileName = StrZToStr(.lpstrFile)
        vFileTitle = StrZToStr(.lpstrFileTitle)
        vFlags = .Flags
        vFilterIndex = .nFilterIndex
    Else
        VBGetSaveFileName = False
        vFileName = sEmpty
        vFileTitle = sEmpty
        vFlags = 0
        vFilterIndex = 0
    End If
End With
End Function

Function VBGetFileTitle(sFile As String) As String
    Dim sFileTitle As String, cFileTitle As Integer

    cFileTitle = cMaxPath
    sFileTitle = String$(cMaxPath, 0)
    cFileTitle = GetFileTitle(sFile, sFileTitle, cMaxPath)
    If cFileTitle Then
        VBGetFileTitle = sEmpty
    Else
        VBGetFileTitle = Left$(sFileTitle, InStr(sFileTitle, sNullChr) - 1)
    End If

End Function


' ChooseColor wrapper
Function VBChooseColor(vColor As Variant, _
                       Optional vFlags As Variant, _
                       Optional vOwner As Variant) As Boolean

    Dim chclr As TChooseColor
    chclr.lStructSize = Len(chclr)
    
    ' vColor must get reference variable to receive result
    ' vFlags can get reference variable or constant with bit flags
    If IsMissing(vFlags) Then vFlags = 0
    ' vOwner can take handle of owning window
    If Not IsMissing(vOwner) Then chclr.hwndOwner = vOwner

    ' Assign color (default uninitialized value of zero is good default)
    chclr.rgbResult = vColor

    ' Pass in flags, stripping out non-VB flags
    chclr.Flags = vFlags And &HF

    ' If first time, initialize to white
    If fNotFirst = False Then InitColors

    chclr.lpCustColors = GetRefPtr(alCustom(0))

    ' All other fields zero
    'chclr.hInstance = hNull            ' No templates
    'chclr.lpTemplateName = pNull
    'chclr.lCustData = pNull            ' No hooks
    'chclr.lpfnHook = pNull
    
    If ChooseColor(chclr) Then
        VBChooseColor = True
        vColor = chclr.rgbResult
        vFlags = chclr.Flags
    Else
        VBChooseColor = False
        vColor = -1
        vFlags = 0
    End If

End Function

' Property to read or modify custom colors (use to save colors in .INI file)
Public Property Get CustomColor(i As Integer) As Long
    ' If first time, initialize to white
    If fNotFirst = False Then InitColors
    If i >= 0 And i <= 15 Then
        CustomColor = alCustom(i)
    Else
        CustomColor = -1
    End If
End Property

Public Property Let CustomColor(i As Integer, iValue As Long)
    ' If first time, initialize to white
    If fNotFirst = False Then InitColors
    If i >= 0 And i <= 15 Then
        alCustom(i) = iValue
    End If
End Property

Private Sub InitColors()
    Dim i As Integer
    For i = 0 To 15
        alCustom(i) = vbWhite
    Next
    fNotFirst = True
End Sub

' ChooseFont wrapper
Function VBChooseFont(vFont As Font, _
                      Optional vFlags As Variant, _
                      Optional vPrinterDC As Variant, _
                      Optional vOwner As Variant, _
                      Optional vColor As Variant, _
                      Optional vMinSize As Variant, _
                      Optional vMaxSize As Variant) As Boolean

    ' vFlags can get reference variable or constant with bit flags
    If IsMissing(vFlags) Then vFlags = 0
    ' vPrinterDC can take printer DC
    If IsMissing(vPrinterDC) Then
        vPrinterDC = 0
        If vFlags And cdlCFPrinterFonts Then vPrinterDC = Printer.hDC
    Else
        vFlags = vFlags Or cdlCFPrinterFonts
    End If
    ' Must have some fonts
    If (vFlags And cdlCFPrinterFonts) = 0 Then vFlags = vFlags Or cdlCFScreenFonts
    ' vOwner can take handle of owning window
    If IsMissing(vOwner) Then vOwner = 0
    ' vColor can take initial color, receive chosen color
    If IsMissing(vColor) Then
        vColor = vbBlack
    Else
        vFlags = vFlags Or cdlCFEffects
    End If
    ' vMinSize can be minimum size accepted
    If IsMissing(vMinSize) Then
        vMinSize = 0
    Else
        vFlags = vFlags Or cdlCFLimitSize
    End If
    ' vMaxSize can be maximum size accepted
    If IsMissing(vMaxSize) Then
        vMaxSize = 0
    Else
        vFlags = vFlags Or cdlCFLimitSize
    End If

    ' Put in required internal flags and remove unsupported
    vFlags = (vFlags Or cdlCFInitToLogFontStruct) And Not cdlCFFontNotSupported
    
    ' Initialize TLogFontB variable
    Dim lfnt As TLogFontB
    Const PointsPerTwip = 1440 / 72
    lfnt.Height = -(vFont.Size * (PointsPerTwip / Screen.TwipsPerPixelY))
    'lfnt.Width = 0
    'lfnt.Escapement = 0
    'lfnt.Orientation = 0
    lfnt.Weight = vFont.Weight
    lfnt.Italic = vFont.Italic
    lfnt.Underline = vFont.Underline
    lfnt.StrikeOut = vFont.Strikethrough
    'lfnt.CharSet = 0
    'lfnt.OutPrecision = 0
    'lfnt.ClipPrecision = 0
    'lfnt.Quality = 0
    'lfnt.PitchAndFamily = 0
    StrToBytes lfnt.FaceName, vFont.Name

    ' Initialize TChooseFont variable
    Dim fnt As TChooseFont
    fnt.lStructSize = Len(fnt)
    fnt.hwndOwner = vOwner
    fnt.hDC = vPrinterDC
''@B InitLogFont
#Const HalfDozen = 1
#If Six Then
    fnt.lpLogFont = VarPtr(lfnt)
#ElseIf HalfDozen Then
    fnt.lpLogFont = GetRefPtr(lfnt)
#End If
''@E InitLogFont
    fnt.iPointSize = vFont.Size * 10
    fnt.Flags = vFlags
    fnt.rgbColors = vColor
    fnt.nSizeMin = vMinSize
    fnt.nSizeMax = vMaxSize
    
    ' All other fields zero
    'fnt.lCustData = pNull          ' No hooks
    'fnt.lpfnHook = pNull
    'fnt.lpTemplateName = pNull     ' No templates
    'fnt.hInstance = hNull
    'fnt.lpszStyle = sNullStr       ' Use LogFont instead
    'fnt.nFontType = 0
    
    If ChooseFont(fnt) Then
        VBChooseFont = True
        vFlags = fnt.Flags
        vColor = fnt.rgbColors
        vFont.Bold = fnt.nFontType And Bold_FontType
        'vFont.Italic = fnt.nFontType And Italic_FontType
        vFont.Italic = lfnt.Italic
        vFont.Strikethrough = lfnt.StrikeOut
        vFont.Underline = lfnt.Underline
        vFont.Weight = lfnt.Weight
        vFont.Size = fnt.iPointSize / 10
        vFont.Name = BytesToStr(lfnt.FaceName)
    Else
        VBChooseFont = False
    End If

End Function

#If YouDoIt Then
' PrintDlg wrapper
Function VBPrintDlg(vFont As Variant, _
                    Optional vPoints As Variant, _
                    Optional vPrinterDC As Variant, _
                    Optional vFlags As Variant, _
                    Optional vOwner As Variant, _
                    Optional vColor As Variant, _
                    Optional vStyle As Variant, _
                    Optional vFontType As Variant, _
                    Optional vMinSize As Variant, _
                    Optional vMaxSize As Variant) As Boolean

    MsgBox "Left as an exercise for the reader"
    Exit Function
    
    Dim prt As TPrintDlg
    prt.lStructSize = Len(prt)
    
    ' Insert implementation here
    
    If PrintDlg(prt) Then
        VBPrintDlg = True
    Else
        VBPrintDlg = False
    End If

End Function
#End If

